searchNodes=[{"ref":"Customerio.html","title":"Customerio","type":"module","doc":"Main module to interact with API."},{"ref":"Customerio.html#add_device/5","title":"Customerio.add_device/5","type":"function","doc":"Create or update a customer device. Params id - the unique identifier for the customer. device_id - The unique token for the user device. platform - The platform for the user device. Allowed values are &#39;ios&#39; and &#39;android&#39;. data_map - custom attributes to define the request: last_used - UNIX timestamp representing the last used time for the device. If this is not included we default to the time of the device identify. opts - HTTPoison options. Example iex&gt; Customerio.add_device(5, &quot;my_ios_device_id&quot;, &quot;ios&quot;, %{last_used: 1514764800}) {:ok, &quot;...&quot;} iex&gt; Customerio.add_device(5, &quot;my_ios_device_id&quot;, &quot;epic_fail_devise&quot;) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#add_device!/5","title":"Customerio.add_device!/5","type":"function","doc":"Create or update a customer device. Raises Customerio.Error if fails. Params id - the unique identifier for the customer. device_id - The unique token for the user device. platform - The platform for the user device. Allowed values are &#39;ios&#39; and &#39;android&#39;. data_map - custom attributes to define the request: last_used - UNIX timestamp representing the last used time for the device. If this is not included we default to the time of the device identify. opts - HTTPoison options. Example iex&gt; Customerio.add_device(5, &quot;my_ios_device_id&quot;, &quot;ios&quot;, %{last_used: 1514764800}) &quot;...&quot; iex&gt; Customerio.add_device(5, &quot;my_ios_device_id&quot;, &quot;epic_fail_devise&quot;) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#add_to_segment/3","title":"Customerio.add_to_segment/3","type":"function","doc":"Add the list of customer ids to the specified manual segment. If you send customer ids that don&#39;t exist yet in an add_to_segment request, we will automatically create customer profiles for the new customer ids. Params id - the unique identifier of the segment. ids - a list of customer ids to add to the segment. opts - HTTPoison options. Example iex&gt; Customerio.add_to_segment(1, [1, 2, 3]) {:ok, &quot;...&quot;} iex&gt; Customerio.add_to_segment(1000, [1, 2, 3]) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#add_to_segment!/3","title":"Customerio.add_to_segment!/3","type":"function","doc":"Add the list of customer ids to the specified manual segment. If you send customer ids that don&#39;t exist yet in an add_to_segment request, we will automatically create customer profiles for the new customer ids. Raises Customerio.Error if fails. Params id - the unique identifier of the segment. ids - a list of customer ids to add to the segment. opts - HTTPoison options. Example iex&gt; Customerio.add_to_segment!(1, [1, 2, 3]) &quot;...&quot; iex&gt; Customerio.add_to_segment(1000, [1, 2, 3]) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#anonymous_track/3","title":"Customerio.anonymous_track/3","type":"function","doc":"Track anonymous events directly without customer ID. Params name - the name of the event to track. data_map - custom attributes to define the customer. opts - HTTPoison options. Example iex&gt; Customerio.anonymous_track(&quot;purchase&quot;, %{recipient: &quot;success@example.com&quot;}) {:ok, &quot;...&quot;} iex&gt; Customerio.anonymous_track(&quot;purchase&quot;, %{recipient: &quot;fail@example.com&quot;}) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#anonymous_track!/3","title":"Customerio.anonymous_track!/3","type":"function","doc":"Track anonymous events directly without customer ID. Raises Customerio.Error if fails. Params name - the name of the event to track. data_map - custom attributes to define the customer. opts - HTTPoison options. Example iex&gt; Customerio.anonymous_track!(&quot;purchase&quot;, %{recipient: &quot;success@example.com&quot;}) &quot;...&quot; iex&gt; Customerio.anonymous_track!(&quot;purchase&quot;, %{recipient: &quot;fail@example.com&quot;}) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#delete/2","title":"Customerio.delete/2","type":"function","doc":"Delete customers. Params id - the unique identifier for the customer. opts - HTTPoison options. Example iex&gt; Customerio.delete(5) {:ok, &quot;...&quot;} iex&gt; Customerio.delete(6) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#delete!/2","title":"Customerio.delete!/2","type":"function","doc":"Delete customers. Raises Customerio.Error if fails. Params id - the unique identifier for the customer. opts - HTTPoison options. Example iex&gt; Customerio.delete!(5) &quot;,,,&quot; iex&gt; Customerio.delete!(6) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#delete_device/3","title":"Customerio.delete_device/3","type":"function","doc":"Delete a customer device. Params id - the unique identifier for the customer. device_id - the unique token for the user device. opts - HTTPoison options. Example iex&gt; Customerio.delete_device(5, :my_device) {:ok, &quot;...&quot;} iex&gt; Customerio.delete_device(6, :fail_device) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#delete_device!/3","title":"Customerio.delete_device!/3","type":"function","doc":"Delete a customer device. Raises Customerio.Error if fails. Params id - the unique identifier for the customer. device_id - the unique token for the user device. opts - HTTPoison options. Example iex&gt; Customerio.delete_device!(5, :my_device) &quot;...&quot; iex&gt; Customerio.delete_device!(6, :fail_device) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#identify/3","title":"Customerio.identify/3","type":"function","doc":"Creating or updating customers. Params id - the unique identifier for the customer. data_map - custom attributes to define the customer. opts - HTTPoison options. Example iex&gt; Customerio.identify(5, %{email: &quot;success@example.com&quot;}) {:ok, &quot;...&quot;} iex&gt; Customerio.identify(6, %{email: &quot;fail@example.com&quot;}) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#identify!/3","title":"Customerio.identify!/3","type":"function","doc":"Creating or updating customers. Raises Customerio.Error if fails. Params id - the unique identifier for the customer. data_map - custom attributes to define the customer. opts - HTTPoison options. Example iex&gt; Customerio.identify!(5, %{email: &quot;success@example.com&quot;}) &quot;..&quot; iex&gt; Customerio.identify!(6, %{email: &quot;fail@example.com&quot;}) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#remove_from_segment/3","title":"Customerio.remove_from_segment/3","type":"function","doc":"Remove the list of customer ids from the specified manual segment. Params id - the unique identifier of the segment. ids - a list of customer ids to add to the segment. opts - HTTPoison options. Example iex&gt; Customerio.remove_from_segment(1, [1, 2, 3]) {:ok, &quot;...&quot;} iex&gt; Customerio.remove_from_segment(1000, [1, 2, 3]) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#remove_from_segment!/3","title":"Customerio.remove_from_segment!/3","type":"function","doc":"Remove the list of customer ids from the specified manual segment. Raises Customerio.Error if fails. Params id - the unique identifier of the segment. ids - a list of customer ids to add to the segment. opts - HTTPoison options. Example iex&gt; Customerio.remove_from_segment!(1, [1, 2, 3]) &quot;...&quot; iex&gt; Customerio.remove_from_segment(1000, [1, 2, 3]) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#suppress/2","title":"Customerio.suppress/2","type":"function","doc":"Deletes the customer with the provided id if it exists and suppresses all future events and identifies for for that customer. Params id - the unique identifier for the customer. opts - HTTPoison options. Example iex&gt; Customerio.suppress(5) {:ok, &quot;...&quot;} iex&gt; Customerio.suppress(6) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#suppress!/2","title":"Customerio.suppress!/2","type":"function","doc":"Deletes the customer with the provided id if it exists and suppresses all future events and identifies for for that customer. Raises Customerio.Error if fails. Params id - the unique identifier for the customer. opts - HTTPoison options. Example iex&gt; Customerio.suppress!(5) &quot;...&quot; iex&gt; Customerio.suppress!(6) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#track/4","title":"Customerio.track/4","type":"function","doc":"Track the event for given customer. Params id - the unique identifier for the customer. name - the name of the event to track. data_map - custom attributes to define the customer. opts - HTTPoison options. Example iex&gt; Customerio.track(5, &quot;purchase&quot;, %{price: 23,45}) {:ok, &quot;...&quot;} iex&gt; Customerio.track(6, &quot;crash&quot;, %{reason: &quot;epic fail&quot;}) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#track!/4","title":"Customerio.track!/4","type":"function","doc":"Track the event for given customer. Raises Customerio.Error if fails. Params id - the unique identifier for the customer. name - the name of the event to track. data_map - custom attributes to define the customer. opts - HTTPoison options. Example iex&gt; Customerio.track!(5, &quot;purchase&quot;, %{price: 23,45}) &quot;...&quot; iex&gt; Customerio.track!(6, &quot;crash&quot;, %{reason: &quot;epic fail&quot;}) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#track_page_view/4","title":"Customerio.track_page_view/4","type":"function","doc":"Track page view event directly with customer ID. Params id - the unique identifier for the customer. page_name - the URL of the page. data_map - custom attributes to define the customer. opts - HTTPoison options. Example iex&gt; Customerio.track_page_view(5, &quot;http://google.com&quot;, %{ref: &quot;success&quot;}) {:ok, &quot;...&quot;} iex&gt; Customerio.track_page_view(5, &quot;http://google.com&quot;, %{ref: &quot;fail&quot;}) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#track_page_view!/4","title":"Customerio.track_page_view!/4","type":"function","doc":"Track page view event directly with customer ID. Raises Customerio.Error if fails. Params id - the unique identifier for the customer. page_name - the URL of the page. data_map - custom attributes to define the customer. opts - HTTPoison options. Example iex&gt; Customerio.track_page_view!(5, &quot;http://google.com&quot;, %{ref: &quot;success&quot;}) &quot;...&quot; iex&gt; Customerio.track_page_view!(5, &quot;http://google.com&quot;, %{ref: &quot;fail&quot;}) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#trigger_campaign/3","title":"Customerio.trigger_campaign/3","type":"function","doc":"Trigger a campaign execution. Params id - the unique identifier of the campaign. data - data to be included in the campaign. Example iex&gt; Customerio.trigger_campaign(1, %{data: %{title: &quot;hello&quot;}}) {:ok, &quot;{...}&quot;} iex&gt; Customerio.trigger_campaign(666, %{data: %{title: &quot;heaven company&quot;}}) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#trigger_campaign!/3","title":"Customerio.trigger_campaign!/3","type":"function","doc":"Trigger a campaign execution. Raises Customerio.Error if fails. Params id - the unique identifier of the campaign. data - data to be included in the campaign. Example iex&gt; Customerio.trigger_campaign(1, %{data: %{title: &quot;hello&quot;}}) {:ok, &quot;{...}&quot;} iex&gt; Customerio.trigger_campaign(666, %{data: %{title: &quot;heaven company&quot;}}) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#unsuppress/2","title":"Customerio.unsuppress/2","type":"function","doc":"Start tracking events and identifies again for a previously suppressed customer. Note when a user is suppressed thier history is deleted and unsupressing them wil not recover that history. Params id - the unique identifier for the customer. opts - HTTPoison options. Example iex&gt; Customerio.unsuppress(5) {:ok, &quot;...&quot;} iex&gt; Customerio.unsuppress(6) {:error, %Customerio.Error{}}"},{"ref":"Customerio.html#unsuppress!/2","title":"Customerio.unsuppress!/2","type":"function","doc":"Start tracking events and identifies again for a previously suppressed customer. Note when a user is suppressed thier history is deleted and unsupressing them wil not recover that history. Raises Customerio.Error if fails. Params id - the unique identifier for the customer. opts - HTTPoison options. Example iex&gt; Customerio.unsuppress!(5) &quot;...&quot; iex&gt; Customerio.unsuppress!(6) ** (Customerio.Error) &quot;Epic fail!&quot;"},{"ref":"Customerio.html#t:result/0","title":"Customerio.result/0","type":"type","doc":"Represents the type of an Customer.IO API answers"},{"ref":"Customerio.html#t:value/0","title":"Customerio.value/0","type":"type","doc":"Represents fuzzy type that can be used to send data to Customer.IO"},{"ref":"Customerio.Error.html","title":"Customerio.Error","type":"exception","doc":"Customer.IO API error exeption"},{"ref":"Customerio.Error.html#message/1","title":"Customerio.Error.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Customerio.Error.html#t:t/0","title":"Customerio.Error.t/0","type":"type","doc":"Customer.IO API error"},{"ref":"getting-started.html","title":"Getting Started","type":"extras","doc":"Getting Started"},{"ref":"getting-started.html#installation","title":"Getting Started - Installation","type":"extras","doc":"The package can be installed by adding customerio to your list of dependencies in mix.exs: def deps do [{:customerio, &quot;~&gt; 0.2&quot;}] end After that execute: $ mix deps.get"},{"ref":"getting-started.html#api-client-vs-javascript-snippet","title":"Getting Started - API client vs. JavaScript snippet","type":"extras","doc":"The JavaScript snippet tracks basic behavior for you just by copy/pasting it onto your site. In many cases, using the JavaScript snippet will be easier to integrate with your app, but there are several reasons why sending events from your backend is useful: You’re not planning on triggering emails based on how customers interact with your website (e.g. users who haven’t visited the site in X days) You’re using the javascript snippet, but have a few events you’d like to send from your backend system. They will work well together! You’d rather not have another javascript snippet slowing down your frontend. Our snippet is asynchronous (doesn’t affect initial page load) and very small, but we understand. In the end, the decision on whether or not to send events from your backend or the JavaScript snippet should be based on what works best for you. You’ll be able to integrate fully with Customer.io with either approach."},{"ref":"usage.html","title":"Usage","type":"extras","doc":"Usage"},{"ref":"usage.html#setup","title":"Usage - Setup","type":"extras","doc":"Specify configuration in your config files: # config/config.exs config :customerio, site_id: %your_site_id%, api_key: %your_api_key% Now, you can call all the functions from every place in your code."},{"ref":"usage.html#identify-logged-in-customers","title":"Usage - Identify logged in customers","type":"extras","doc":"Identify logged in customers Tracking data of logged in customers is a key part of Customer.io. In order to send triggered emails, we must know the email address of the customer. You can also specify any number of customer attributes which help tailor Customer.io to your business. Attributes you specify are useful in several ways: As customer variables in your triggered emails. For instance, if you specify the customer&#39;s name, you can personalize the triggered email by using it in the subject or body. As a way to filter who should receive a triggered email. For instance, if you pass along the current subscription plan (free / basic / premium) for your customers, you can set up triggers which are only sent to customers who have subscribed to a particular plan (e.g. &quot;premium&quot;). You&#39;ll want to indentify your customers when they sign up for your app and any time their key information changes. This keeps Customer.io up to date with your customer information. Customerio.identify( 5, # id %{ # attributes map email: &quot;bob@example.com&quot;, created_at: :os.system_time(:seconds), first_name: &quot;Bob&quot;, plan: &quot;basic&quot; } )"},{"ref":"usage.html#deleting-customers","title":"Usage - Deleting customers","type":"extras","doc":"Deleting a customer will remove them, and all their information from Customer.io. Note: if you&#39;re still sending data to Customer.io via other means (such as the javascript snippet), the customer could be recreated. Customerio.identify( 5 # id )"},{"ref":"usage.html#tracking-a-custom-event","title":"Usage - Tracking a custom event","type":"extras","doc":"Now that you&#39;re identifying your customers with Customer.io, you can now send events like &quot;purchased&quot; or &quot;watchedIntroVideo&quot;. These allow you to more specifically target your users with automated emails, and track conversions when you&#39;re sending automated emails to encourage your customers to perform an action. Customerio.track( 5, # id &quot;purchase&quot;, # name %{ # attributes map type: &quot;socks&quot;, price: &quot;13.99&quot; } ) Note: If you&#39;d like to track events which occurred in the past, you can include a timestamp attribute (in seconds since the epoch), and we&#39;ll use that as the date the event occurred. Customerio.track(5, &quot;purchase&quot;, %{type: &quot;socks&quot;, price: &quot;13.99&quot;, timestamp: 1365436200)"},{"ref":"usage.html#tracking-anonymous-events","title":"Usage - Tracking anonymous events","type":"extras","doc":"You can also send anonymous events, for situations where you don&#39;t yet have a customer record but still want to trigger a campaign: Customerio.anonymous_track(&quot;help_enquiry&quot;, %{recipient: &#39;user@example.com&#39;) Use the recipient attribute to specify the email address to send the messages to. See documentation on how to use anonymous events for more details."},{"ref":"usage.html#page-view-events","title":"Usage - Page View Events","type":"extras","doc":"You can send a page view event to Customer.io directly, defining a customer and page url. Customerio.track_page_view(5, &quot;http://google.com&quot;, %{refferer: &quot;bob&quot;}) The Javascript snippet automatically sends these events based on when any page that includes it is loaded."}]